<?php
$unique = array();
$stringdb = array();
for ($i = 1; $i < count($argv); $i++) {
	$filename = "./" . $argv[$i];
	//echo "--" . $argv[$i] . "\n";
	$line = 1;
	$handle = @fopen($filename, "r");
	if ($handle) {
		$nearestfunction = $argv[$i];
		while (!feof($handle)) {
			$buffer = fgets($handle, 4096);
			if (substr(trim($buffer), 0, 2) != "--") {
				preg_match("/function ([a-zA-Z0-9:_-]+)\(/", $buffer, $functionm);
				if (count($functionm[1]) > 0) {
					//print_r($functionm[1]);
					$nearestfunction = $functionm[1];
				}
				preg_match_all("/L\[[\"'](.+)['\"]\]/U", $buffer, $matches);
				preg_match("/--(.+)$/", $buffer, $context);
				if (count($matches[1]) > 0) {
					$scontext = trim($context[1]);
					foreach ($matches[1] as $string) {
						if (!$unique[$string]) {
							// echo "L[\"" . $string . "\"] -- $line:$context\n";
							if (preg_match("/[A-Z0-9_]{3,}/", $string)) {
								$haslongtext = true;
							}
							$unique[$string] = $argv[$i];
							$stringdb[$argv[$i]][$string] = array("line" => $line, "context" => array($scontext));
						} else {
							// print_r($context);
							if (array_search($scontext, $stringdb[$unique[$string]][$string]['context']) === FALSE) {
								$stringdb[$unique[$string]][$string]['context'][] = $scontext;
							}
						}
					}
				}
			}
			$line++;
		}
		fclose($handle);
	}
	
	//echo "\n";
}
//print_r($stringdb);
echo "-- enUS.lua\n";
foreach ($stringdb as $file => $strings) {
	echo "--" . $file . "\n";
	foreach ($strings as $string => $details) {
		echo "L[\"" . $string . "\"] = true -- " . $details["line"] . ":" . implode("; ", $details['context']) . "\n";
	}
	echo "\n";
}
echo "\n\n";
// get all the old locale strings!
$locales = array("enUS" => array(), "frFR" => array(), "deDE" => array(), "esES" => array(), "esMX" => array(), "koKR" => array(), "ruRU" => array(), "zhCN" => array(), "zhTW" => array());
foreach ($locales as $key => $locale) {
	$filename = "./old locales/" . $key . ".lua";
	$handle = @fopen($filename, "r");
	$contents = fread($handle, filesize($filename));
	fclose($handle);
	preg_match_all("/^L\[\"(.+)\"\] = (true|\"(.+)\"|\[=\[(.+)\]=\])/msU", $contents, $matches);
	//print_r($matches);
	foreach ($matches[1] as $k => $phrase) {
		if (isset($unique[$phrase])) {
			if ($matches[2][$k] != "") {
				$locales[$key][$phrase] = $matches[2][$k];
			} elseif ($matches[3][$k] != "") {
				$locales[$key][$phrase] = $matches[3][$k];
			} elseif ($matches[4][$k] != "") {
				$locales[$key][$phrase] = $matches[4][$k];
			}
		}
	} 
	echo "-- $key.lua\n";
	foreach ($stringdb as $file => $strings) {
		echo "--" . $file . "\n";
		foreach ($strings as $string => $details) {
			if (isset($locales[$key][$string]) || $key == "enUS") {
				echo "L[\"" . $string . "\"] = " . (isset($locales[$key][$string]) ? $locales[$key][$string] : "true") . "\n";
			}
		}
		echo "\n";
	}
	echo "\n\n";
}





?>