local debug = false
--[===[@debug@
debug = true
--@end-debug@]===]

local L = LibStub("AceLocale-3.0"):NewLocale("EveryQuest", "enUS", true, debug)

L["- Select -"] = true
L["Core/1 day ago"] = "1 day ago"
L["Core/1 day %d hr ago"] = "1 day %d hr ago"
L["Core/1 minute ago"] = "1 minute ago"
L["Core/1 second ago"] = "1 second ago"
L["Core/Abandoned"] = "Abandoned"
L["Core/Abandoned: %s"] = "Abandoned: %s"
L["Core/Cancel"] = "Cancel"
L["Core/Completed"] = "Completed"
L["Core/Completed%s: %s"] = "Completed%s: %s"
L["Core/Could not load %s Quest Data because of %s"] = "Could not load %s Quest Data because of %s"
L["Core/D"] = "D"
L["Core/%d days ago"] = "%d days ago"
L["Core/%d days %d hr ago"] = "%d days %d hr ago"
L["Core/%d hr ago"] = "%d hr ago"
L["Core/%d hr %d min ago"] = "%d hr %d min ago"
L["Core/%d minutes ago"] = "%d minutes ago"
L["Core/%d seconds ago"] = "%d seconds ago"
L["Core/%d Shown"] = "%d Shown"
L["Core/ (%d Times)"] = " (%d Times)"
L["Core/E"] = "E"
L["Core/EQ_PURGETXT"] = "Are you sure you want to purge all old data? If you are unsure, or just completed an upgrade, cancel and check the EveryQuest window to see if your quests are there. To continue type 'DELETE' in the box below. This action is irreversible. You can clear the database later using the interface options"
L["Core/EQ_UPGRADETXT"] = "EveryQuest has detected %s out of date database(s) (resulting from a version upgrade), click Yes to attempt to upgrade. This may take a moment. You can upgrade later using the interface options"
L["Core/Failed"] = "Failed"
L["Core/Failed or Abandoned"] = "Failed or Abandoned"
L["Core/Failed: %s"] = "Failed: %s"
L["Core/Forget"] = "Forget"
L["Core/G"] = "G"
L["Core/H"] = "H"
L["Core/Ignore"] = "Ignore"
L["Core/Imported From: %s"] = "Imported From: %s"
L["Core/In Progress"] = "In Progress"
L["Core/Loading %s Quest Data"] = "Loading %s Quest Data"
L["Core/%m/%d/%y %I%p"] = "%m/%d/%y %I%p"
L["Core/Other"] = "Other"
L["Core/P"] = "P"
L["Core/Purge"] = "Purge"
L["Core/PURGE_ERROR"] = "You have not entered the correct text to delete old data. Please read the message!"
L["Core/QuestGuru"] = "QuestGuru"
L["Core/QuestHistory"] = "QuestHistory"
L["Core/R"] = "R"
L["Core/r%d"] = "r%d"
L["Core/Requires LOD Module: %s"] = "Requires LOD Module: %s"
L["Core/Server Query"] = "Server Query"
L["Core/Status: %s"] = "Status: %s"
L["Core/Turned In"] = "Turned In"
L["Core/Unknown"] = "Unknown"
L["Core/Upgrade"] = "Upgrade"
L["Core/W"] = "W"
L["Core/WE"] = "WE"
L["Core/Y"] = "Y"
L["Core/You are running an ALPHA RELEASE of EveryQuest %s (revision %d). Please report any bugs @ http://www.wowace.com/addons/everyquest/tickets/"] = "You are running an ALPHA RELEASE of EveryQuest %s (revision %d). Please report any bugs @ http://www.wowace.com/addons/everyquest/tickets/"
L["Core/You are running a source checkout of EveryQuest %s directly from the repository."] = "You are running a source checkout of EveryQuest %s directly from the repository."
L["Events/Abandon Quest: %s"] = "Abandon Quest: %s"
L["Events/Complete Quest: %s"] = "Complete Quest: %s"
L["Events/Failed Quest: %s"] = "Failed Quest: %s"
L["Events/Obtained Quest: %s"] = "Obtained Quest: %s"
L["Events/Turn In Quest: %s"] = "Turn In Quest: %s"
L["Events/Unable to get Quest Information from DB"] = "Unable to get Quest Information from DB"
L["Frames/Click to toggle the main window"] = "Click to toggle the main window"
L["Frames/%d Completed"] = "%d Completed"
L["Frames/%d Failed/Abandoned"] = "%d Failed/Abandoned"
L["Frames/%d Ignored"] = "%d Ignored"
L["Frames/%d In Progress"] = "%d In Progress"
L["Frames/%d Turned In"] = "%d Turned In"
L["Frames/%d Unknown"] = "%d Unknown"
L["Frames/EveryQuest"] = "EveryQuest"
L["Frames/EveryQuest Log"] = "EveryQuest Log"
L["Frames/Filters"] = "Filters"
L["Frames/Options"] = "Options"
L["Frames/Right-click to open the options menu"] = "Right-click to open the options menu"
L["Frames/- Select -"] = "- Select -"
L["Frames/Toggle Frame"] = "Toggle Frame"
L["Import/Clear Import Confirm"] = "Clear Import Confirm"
L["Import/Clear Imported Data"] = "Clear Imported Data"
L["Import/Delete any quest tagged as being imported."] = "Delete any quest tagged as being imported."
L["Import/Deleted %d quests from your database"] = "Deleted %d quests from your database"
L["Import/EQ_IMPORT"] = [=[Here you can import quest history from other addons. Currently only QuestGuru and QuestHistory are supported.

|cffFFAFAFNOTE: To import all of your data, you will need to repeat this function on all your characters while the addon you are importing from is loaded. This is a limitation in EveryQuest storing data per-character rather then globally (this saves you memory/startup time).|r]=]
L["Import/EQ_IMPORT_TRAILER"] = "If either of these buttons are disabled, that means you don't have the necessary addon loaded. Logout and enable the addon to import your data."
L["Import/Import"] = "Import"
L["Import/Imported %d quests from %s"] = "Imported %d quests from %s"
L["Import/Import failed, you have no data relating to this character on this server."] = "Import failed, you have no data relating to this character on this server."
L["Import/Import QuestGuru Data"] = "Import QuestGuru Data"
L["Import/Import QuestHistory Data"] = "Import QuestHistory Data"
L["Import/QuestHistory importing is strictly alpha quality. This is due to having to guess at which quest you are trying to import."] = "QuestHistory importing is strictly alpha quality. This is due to having to guess at which quest you are trying to import."
L["Options/Alliance"] = "Alliance"
L["Options/Both Factions"] = "Both Factions"
L["Options/Completed Quests"] = "Completed Quests"
L["Options/Configure filtering options for the quest list. These settings are character specific."] = "Configure filtering options for the quest list. These settings are character specific."
L["Options/Control the display of specific quest statuses"] = "Control the display of specific quest statuses"
L["Options/Daily Quests"] = "Daily Quests"
L["Options/Dungeon Quests"] = "Dungeon Quests"
L["Options/Enable Filtering"] = "Enable Filtering"
L["Options/EQ_DESC"] = "EveryQuest allows you to track which quests you've completed in a friendly list. It will also show you what quests are available in each zone. Combine this addon with LightHeaded and TomTom for the ultimate questing experience"
L["Options/Example for Ignored quest: Some quests are still in Wowhead's database but are not attainable ingame anymore. Ignore them to hide them from the list."] = "Example for Ignored quest: Some quests are still in Wowhead's database but are not attainable ingame anymore. Ignore them to hide them from the list."
L["Options/Faction Filter"] = "Faction Filter"
L["Options/Failed or Abandoned Quests"] = "Failed or Abandoned Quests"
L["Options/Filter Quests by Level"] = "Filter Quests by Level"
L["Options/Filter Quests by Type"] = "Filter Quests by Type"
L["Options/General Settings"] = "General Settings"
L["Options/Group Quests"] = "Group Quests"
L["Options/Heroic Quests"] = "Heroic Quests"
L["Options/Horde"] = "Horde"
L["Options/Ignored Quests"] = "Ignored Quests"
L["Options/Level Filter"] = "Level Filter"
L["Options/Maximum Level"] = "Maximum Level"
L["Options/Minimum Level"] = "Minimum Level"
L["Options/More Numbers"] = "More Numbers"
L["Options/Normal Quests"] = "Normal Quests"
L["Options/No Side/No Data"] = "No Side/No Data"
L["Options/Purge Old data"] = "Purge Old data"
L["Options/Purge Old database data, generally used after running upgrade"] = "Purge Old database data, generally used after running upgrade"
L["Options/PvP Quests"] = "PvP Quests"
L["Options/Quests In Progress"] = "Quests In Progress"
L["Options/Raid Quests"] = "Raid Quests"
L["Options/Removes 'shown' from the displayed numbers, adds a counts of each status shown."] = "Removes 'shown' from the displayed numbers, adds a counts of each status shown."
L["Options/Saves which zone you where last looking at to load upon login"] = "Saves which zone you where last looking at to load upon login"
L["Options/Save Zone"] = "Save Zone"
L["Options/Show Debugging Messages"] = "Show Debugging Messages"
L["Options/Show Debugging Messages - *WARNING* Spams your default chat frame"] = "Show Debugging Messages - *WARNING* Spams your default chat frame"
L["Options/Show quests for specific faction"] = "Show quests for specific faction"
L["Options/Shows Alliance Quests"] = "Shows Alliance Quests"
L["Options/Shows completed quests still in your questlog"] = "Shows completed quests still in your questlog"
L["Options/Shows daily quests"] = "Shows daily quests"
L["Options/Shows dungeon quests"] = "Shows dungeon quests"
L["Options/Shows 'group suggested' quests"] = "Shows 'group suggested' quests"
L["Options/Shows heroic quests"] = "Shows heroic quests"
L["Options/Shows Horde Quests"] = "Shows Horde Quests"
L["Options/Shows normal Blizzard soloable quests"] = "Shows normal Blizzard soloable quests"
L["Options/Shows PVP quests"] = "Shows PVP quests"
L["Options/Shows quests that are available to both factions"] = "Shows quests that are available to both factions"
L["Options/Shows quests that don't have a side or don't have data for a specific side"] = "Shows quests that don't have a side or don't have data for a specific side"
L["Options/Shows quests that you are on but not completed"] = "Shows quests that you are on but not completed"
L["Options/Shows quests that you have failed or abandoned"] = "Shows quests that you have failed or abandoned"
L["Options/Shows quests turned back into NPCs"] = "Shows quests turned back into NPCs"
L["Options/Shows quests you haven't seen before"] = "Shows quests you haven't seen before"
L["Options/Shows quests you've ignored"] = "Shows quests you've ignored"
L["Options/Shows 'raid suggested' quests"] = "Shows 'raid suggested' quests"
L["Options/Shows weekly quests"] = "Shows weekly quests"
L["Options/Status Filter"] = "Status Filter"
L["Options/Track Zone"] = "Track Zone"
L["Options/Track zone changes and update the EveryQuest list for that zone"] = "Track zone changes and update the EveryQuest list for that zone"
L["Options/Turned In Quests"] = "Turned In Quests"
L["Options/Type Filter"] = "Type Filter"
L["Options/Unknown Status"] = "Unknown Status"
L["Options/Upgrade DB"] = "Upgrade DB"
L["Options/Upgrade the Database from the old format"] = "Upgrade the Database from the old format"
L["Options/Weekly Quests"] = "Weekly Quests"
L["Query/Added %d quests to your database"] = "Added %d quests to your database"
L["Query/Auto Populate"] = "Auto Populate"
L["Query/Consider sending your WTF\\Account\\{account name}\\SavedVariables\\EveryQuest.lua to kandarz@gmail.com"] = "Consider sending your WTF\\Account\\{account name}\\SavedVariables\\EveryQuest.lua to kandarz@gmail.com"
L["Query/EQ_QUERY"] = [=[|cffFFFF00NEW IN 3.3!|r

In this 2 step process, EveryQuest can get your completed quest history from the Blizzard servers! Find those quests you missed before you used EveryQuest.

  |cff00E1FFStep 1:|r Click to query the server.]=]
L["Query/EQ_QUERY2"] = [=[
  |cff00E1FFStep 2:|r Click to populate your client's database. Please be warned, depending on the amount of quests you've completed, this may take some time and your game will 'freeze' during this process. I hope you don't get disconnected.]=]
L["Query/EQ_QUERY_TRAILER"] = [=[
  |cff00E1FFAll done!|r

If you got a red message in your chat window, it means the current EveryQuest database doesn't contain some quests you've done. Do not fret though, Blizzard's log contains special quests that you never actually turned into anyone. Such as |cffFFFF00[FLAG: Tournament Invitation]|r]=]
L["Query/Once the server responds, automatically start the import of quest data"] = "Once the server responds, automatically start the import of quest data"
L["Query/Once you recieve the server responce, populate the database with your completed quests."] = "Once you recieve the server responce, populate the database with your completed quests."
L["Query/Populate History"] = "Populate History"
L["Query/Populate History: %d quests not found in the database."] = "Populate History: %d quests not found in the database."
L["Query/Populating your quest history from the server, this may take a while and might freeze your game."] = "Populating your quest history from the server, this may take a while and might freeze your game."
L["Query/Querying Server for your quest history"] = "Querying Server for your quest history"
L["Query/Query Server"] = "Query Server"
L["Query/Ready to populate your quest history from server"] = "Ready to populate your quest history from server"
L["ZoneMenu/Ahn'Qiraj War Effort"] = "Ahn'Qiraj War Effort"
L["ZoneMenu/Alchemy"] = "Alchemy"
L["ZoneMenu/All"] = "All"
L["ZoneMenu/Battlegrounds"] = "Battlegrounds"
L["ZoneMenu/Blacksmithing"] = "Blacksmithing"
L["ZoneMenu/Brewfest"] = "Brewfest"
L["ZoneMenu/Burning Crusade"] = "Burning Crusade"
L["ZoneMenu/Children's Week"] = "Children's Week"
L["ZoneMenu/Classes"] = "Classes"
L["ZoneMenu/Classic"] = "Classic"
L["ZoneMenu/Cooking"] = "Cooking"
L["ZoneMenu/Darkmoon Faire"] = "Darkmoon Faire"
L["ZoneMenu/Day of the Dead"] = "Day of the Dead"
L["ZoneMenu/Dungeons"] = "Dungeons"
L["ZoneMenu/Engineering"] = "Engineering"
L["ZoneMenu/Epic"] = "Epic"
L["ZoneMenu/First Aid"] = "First Aid"
L["ZoneMenu/Fishing"] = "Fishing"
L["ZoneMenu/Hallow's End"] = "Hallow's End"
L["ZoneMenu/Harvest Festival"] = "Harvest Festival"
L["ZoneMenu/Herbalism"] = "Herbalism"
L["ZoneMenu/Inscription"] = "Inscription"
L["ZoneMenu/Jewelcrafting"] = "Jewelcrafting"
L["ZoneMenu/Leatherworking"] = "Leatherworking"
L["ZoneMenu/Legendary"] = "Legendary"
L["ZoneMenu/Love is in the Air"] = "Love is in the Air"
L["ZoneMenu/Lunar Festival"] = "Lunar Festival"
L["ZoneMenu/Midsummer Fire Festival"] = "Midsummer Fire Festival"
L["ZoneMenu/Miscellaneous"] = "Miscellaneous"
L["ZoneMenu/New Year's Eve"] = "New Year's Eve"
L["ZoneMenu/Noblegarden"] = "Noblegarden"
L["ZoneMenu/Pilgrim's Bounty"] = "Pilgrim's Bounty"
L["ZoneMenu/Professions"] = "Professions"
L["ZoneMenu/Raids"] = "Raids"
L["ZoneMenu/Reputation"] = "Reputation"
L["ZoneMenu/Scourge Invasion"] = "Scourge Invasion"
L["ZoneMenu/Seasonal"] = "Seasonal"
L["ZoneMenu/Skettis"] = "Skettis"
L["ZoneMenu/Tailoring"] = "Tailoring"
L["ZoneMenu/The Black Temple"] = "The Black Temple"
L["ZoneMenu/Timbermaw Hold"] = "Timbermaw Hold"
L["ZoneMenu/Tournament"] = "Tournament"
L["ZoneMenu/Winter Veil"] = "Winter Veil"
L["ZoneMenu/Wrath of the Lich King"] = "Wrath of the Lich King"
